PySide Advanced Examples/fr: Difference between revisions

From FreeCAD Documentation
(Created page with "En utilisant le module PySide depuis FreeCAD, vous avez un contrôle total sur son interface. Vous pouvez par exemple: * Ajouter vos propres panneaux, widgets et barres d'outi...")
(Created page with "== Créer une référence pour la fenêtre principale == Si vous souhaitez travailler sur l'interface FreeCAD, la toute première chose à faire est de créer une référence...")
Line 11: Line 11:
* Changer, rediriger ou ajouter des connexions entre tous ces éléments
* Changer, rediriger ou ajouter des connexions entre tous ces éléments


== Créer une référence pour la fenêtre principale ==
==Create Reference for the Main Window==
Si vous souhaitez travailler sur l'interface FreeCAD, la toute première chose à faire est de créer une référence à la fenêtre principale de FreeCAD:
If you want to work on the FreeCAD interface, the very first thing to do is create a reference to the FreeCAD main window:
{{Code|code=
{{Code|code=
import sys
import sys

Revision as of 19:41, 22 October 2020

Other languages:

Introduction

Le but de cette page est de couvrir des exemples de niveau avancé du gestionnaire GUI PySide (il y a des pages d'accompagnement PySide: Exemples pour débutant et PySide: Exemples pour niveau intermédiaire).

En utilisant le module PySide depuis FreeCAD, vous avez un contrôle total sur son interface. Vous pouvez par exemple:

  • Ajouter vos propres panneaux, widgets et barres d'outils
  • Ajouter ou masquer des éléments aux panneaux existants
  • Changer, rediriger ou ajouter des connexions entre tous ces éléments

Créer une référence pour la fenêtre principale

Si vous souhaitez travailler sur l'interface FreeCAD, la toute première chose à faire est de créer une référence à la fenêtre principale de FreeCAD:

import sys
from PySide import QtGui ,QtCore 
app = QtGui.qApp
mw = FreeCADGui.getMainWindow()

Browse the Children of the Main Window

Then, you can for example browse through all the widgets of the interface:

for child in mw.children():
   print 'widget name = ', child.objectName(), ', widget type = ', child

The widgets in a Qt interface are usually nested into "container" widgets, so the children of our main window can themselves contain other children. Depending on the widget type, there are a lot of things you can do. Check the API documentation to see what is possible.

Add New Widget Manually

Adding a new widget, for example a dockWidget (which can be placed in one of FreeCAD's side panels) is easy:

myWidget = QtGui.QDockWidget()
mw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myWidget)

You could then add stuff directly to your widget:

myWidget.setObjectName("my Nice New Widget")
myWidget.resize(QtCore.QSize(300,100)) # sets size of the widget
label = QtGui.QLabel("Hello World", myWidget) # creates a label
label.setGeometry(QtCore.QRect(2,50,200,24))  # sets its size
label.setObjectName("myLabel") # sets its name, so it can be found by name

Add New Widget by Creating UI Object

But a preferred method is to create a UI object which will do all of the setup of your widget at once. The big advantage is that such an UI object can be created graphically with the Qt Designer program. A typical object generated by Qt Designer is like this:

class myWidget_Ui(object):
  def setupUi(self, myWidget):
    myWidget.setObjectName("my Nice New Widget")
    myWidget.resize(QtCore.QSize(300,100).expandedTo(myWidget.minimumSizeHint())) # sets size of the widget

    self.label = QtGui.QLabel(myWidget) # creates a label
    self.label.setGeometry(QtCore.QRect(50,50,200,24)) # sets its size
    self.label.setObjectName("label") # sets its name, so it can be found by name

  def retranslateUi(self, draftToolbar): # built-in QT function that manages translations of widgets
    myWidget.setWindowTitle(QtGui.QApplication.translate("myWidget", "My Widget", None, QtGui.QApplication.UnicodeUTF8))
    self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))

To use it, you just need to apply it to your freshly created widget like this:

app = QtGui.qApp
FCmw = app.activeWindow()
myNewFreeCADWidget = QtGui.QDockWidget() # create a new dckwidget
myNewFreeCADWidget.ui = myWidget_Ui() # load the Ui script
myNewFreeCADWidget.ui.setupUi(myNewFreeCADWidget) # setup the ui
FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window